<?php
/**
* @version      2.6.0 20.11.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopPaymentMethod extends JTableAvto {

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_payment_method', 'payment_id', $_db );
    }

    function getAllPaymentMethods($publish = 1) {
        $database =& JFactory::getDBO(); 
        $query_where = ($publish)?("WHERE payment_publish = '1'"):("");
        $lang = &JSFactory::getLang();
        $query = "SELECT payment_id, `".$lang->get("name")."` as name, `".$lang->get("description")."` as description , payment_code, payment_class, payment_publish, payment_ordering, payment_params, payment_type, price, tax_id FROM `#__jshopping_payment_method`
                  $query_where
                  ORDER BY payment_ordering";
        $database->setQuery($query);
        return $database->loadObjectList();
    }

    /**
    * get id payment for payment_class
    */
    function getId() {
        $database =& JFactory::getDBO(); 
        $query = "SELECT payment_id FROM `#__jshopping_payment_method` WHERE payment_class = '".$this->_db->getEscaped($this->class)."'";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }    
    
    function getPrice(){
        $jshopConfig = &JSFactory::getConfig();
        $price = $this->price * $jshopConfig->currency_value; 
        $price = getPriceCalcParamsTax($price, $this->tax_id);
        return $price;
    }
    
    function getTax(){        
        $taxes = &JSFactory::getAllTaxes();        
        return $taxes[$this->tax_id];
    }
    
    function calculateTax(){
        $jshopConfig = &JSFactory::getConfig();
        $price = $this->getPrice();
        $pricetax = getPriceTaxValue($price, $this->getTax(), $jshopConfig->display_price_front_current);
        return $pricetax;
    }
    
    /**
    * get params payment for classname    
    */
    function getParamsForClassName($classname) {
        $database =& JFactory::getDBO(); 
        $query = "SELECT payment_params FROM `#__jshopping_payment_method` WHERE payment_class = '".$this->_db->getEscaped($classname)."'";
        $this->_db->setQuery($query);
        $params_str = $this->_db->loadResult();
        $parseString = new parseString($params_str);
        $params = $parseString->parseStringToParams();
        return $params;
    }
}
?>